//     					    ALI CAN SIMSEK
//	               			      FE99G2918
//  			             	    ASIYE OZTURK
//     					      A0009044
//
// 			      ELE 492
//			    HOMEWORK #5
//
//
//OPERATOR OVERLOADING
//RATIONAL.CPP


#include <iostream.h>
#include "rational.h"

rational::rational(int n,int dn)  //constructor fonksiyonu
  {

  //Numerator olarak 2'yi, denominator olarak 4'u default degerler olarak
  //alir. Eger girilen denominator sifirdan kucukse mutlak degerini alir.
  //Yani degeri artiya cevirir.	Eger denominator sifir ise degeri 1'e cevirir.

    numerator=n;
     if (dn < 0)
	dn=-dn;
     if (dn == 0)
	dn=1;
    denominator=dn;
    reduce();
  }

rational rational::operator +(const rational &operand2)
  {
    rational sum;
    sum.numerator = operand2.denominator*numerator+ operand2.numerator*denominator ;
    sum.denominator = operand2.denominator*denominator ;
    sum.reduce(); //sonuc sadelestirilir
    return sum;
  }

rational rational::operator -(const rational &operand2)
  {
    rational diff;
    diff.numerator = operand2.denominator*numerator - operand2.numerator*denominator ;
    diff.denominator = operand2.denominator*denominator ;
    diff.reduce(); //sonuc sadelestirilir
    return diff;
  }

rational rational::operator *(const rational &operand2)
  {
    rational mult;
    mult.numerator = operand2.numerator * numerator ;
    mult.denominator = operand2.denominator*denominator ;
    mult.reduce(); //sonuc sadelestirilir
    return mult;
  }

rational rational::operator /(const rational &operand2)
  {
    rational div;
    div.numerator = operand2.denominator*numerator	;
    div.denominator = operand2.numerator*denominator ;
    div.reduce(); //sonuc sadelestirilir
    return div;
  }

void rational::operator <(const rational &operand2)
  {

  // Bu operatorun etkiledigi operandlara bakarak kucuk olan operandi ekrana
  // yazdirir.

    float small;  //operatorun solundaki degeri belirtir.
    float small1; //operatorun sagindaki degeri belirtir.

    small=(float)numerator / denominator;
    small1=(float) operand2.numerator /operand2.denominator;

    cout<< "The relation between " << this -> numerator << "/"
	<< this->denominator << " and " << operand2.numerator << "/"
	<< operand2.denominator << " is: ";

       if (small < small1)
	  cout << this -> numerator << "/" << this->denominator << " is smaller\n" ;
       else
	  cout << operand2.numerator << "/" << operand2.denominator << " is smaller\n";
  }

void rational::operator >(const rational &operand2)
  {

  // Bu operatorun etkiledigi operandlara bakarak buyuk olan operandi ekrana
  // yazdirir.

    float big;	//operatorun solundaki degeri belirtir.
    float big1; //operatorun sagindaki degeri belirtir.

    big=(float)numerator / denominator;
    big1=(float) operand2.numerator /operand2.denominator;

    cout<< "The relation between " << this -> numerator << "/"
	<< this->denominator << " and " << operand2.numerator << "/"
	<< operand2.denominator << " is: ";

       if (big	> big1)
	  cout << this -> numerator << "/" << this->denominator << " is larger\n";
       else
	  cout << operand2.numerator << "/" << operand2.denominator << " is larger\n";
  }

void rational::reduce(void)
  {

  //Maximum sadelestirme pay ile paydanin birbirinin tamsayi kati olmasi
  //halinde yapilir. O yuzden kucuk olan max olarak alinir ve o degerden
  //1'e kadar rakamlar incelenerek ortak bolenin olup olmadigina bakilir.
  //Varsa pay ile payda ayni sayiya bolunerek sadelestirme yapilir.

   int max,i;
       if (numerator > denominator)
	   max=	denominator;
       else
	   max= numerator;

       for (i=max;i>=2;i--)
       {
	   if ((( numerator % i)==0) && (( denominator % i) == 0))
	    {
	      numerator	   =  numerator   / i;
	      denominator  =  denominator / i;
	    }
       }
  }

void rational::printFP()  const    // Sonucu floating point olarak gosterir
  {
    float result;
    result = (float) numerator / denominator;
    cout << result << "\n" ;
  }

ostream &operator<< (ostream &output, rational &rationa)
  {
    rationa.reduce(); // Output sadelestirilerek ekrana gonderilir.
    output << rationa.numerator << " / "<< rationa.denominator ;
    return output;
  }

istream &operator >> (istream &input, rational &rationa)
  {

  //Inputtan denominator olarak negatif deger ya da 0 girilmesini engellemek
  //icin bu degerler girildiginde kullanici pozitif ve sifirdan buyuk degerler
  //girene kadar dongude bekletilir. Girdigi yanlis degerle ilgili uyarida
  //bulunulur.

    cout << "\nEnter your inputs in the order of numerator , denominator:\n";
    input >> rationa.numerator >> rationa.denominator;
	if ((rationa.denominator) <= 0)
	    {
	       while ( rationa.denominator <= 0 )
		 {
		      if (rationa.denominator == 0)
			  cout << "You entered zero denominator. Please correct your values. \n" ;
		      else
			  cout << "You entered negatif input. Please enter positive ones.\n" ;
		   input >> rationa.numerator >> rationa.denominator;
		 }
	    }
    rationa.reduce(); //Inputtan girilen degerler sadelestirilir.
    return input;
  }

  main()
  {

    rational a,b(5),c(40,-72),d,e,g;
    e=a+b*c;
    e.printFP();
    cout << "a=" <<a <<" b="<<b << " c=" <<c <<" e="<<e ;
    cin >> d;
    cout << "d=" << d << "\n";
    d.printFP();
    g=a+b*c/d-b;
    cout << "g=" << g << "\n";
    e>d;
    e<g;
    return 0;

  }
