
	  #include<iostream.h>
	  #include "rational3.h"

	  Rational::Rational(int numerator,int denumerator)
	  {
			num=numerator;
			den=( denumerator>=0 ) ? denumerator : 1 ;
			reduce();
	  }
	  void Rational::reduce()
	  {
			int i,division;
			division=(num<den) ? num : den ;
			for(i=2;i<=division;i++)
			{
					while((num%i==0)&&(den%i==0))
					{
							num = num / i;
							den = den / i;
					}
			}
	  }
	  Rational Rational::operator+(Rational&R2)
	  {
			 Rational dum;
			 dum.num = num * R2.den + den*R2.num;
			 dum.den = den * R2.den;
			 dum.reduce();
			 return dum;
	  }
	  Rational Rational::operator-(Rational&R2)
		{
			 Rational dum;
			 dum.num = num * R2.den - den * R2.num;
			 dum.den = den * R2.den;
			 dum.reduce();
			 return dum;
	  }
	  Rational Rational::operator*(Rational&R2)
	  {
			 Rational dum;
			 dum.num = num * R2.num;
			 dum.den = den * R2.den;
			 dum.reduce();
			 return dum;
	  }
	  Rational Rational::operator/(Rational&R2)
	  {
			 Rational dum;
			 dum.num = num * R2.den;
			 dum.den = den * R2.num;
			 dum.reduce();
			 return dum;
	  }
	  int Rational::operator==(Rational&R)
	  {
			 if((num==R.num)&&(den==R.den))
					return 1;
			 else
					return 0;
	  }
	  int Rational::operator<(Rational&R)
	  {
			 if((num*R.den)<(den*R.num))
					return 1;
			 else
					return 0;
	  }
	  int Rational::operator>(Rational&R)
	  {
			 if((num*R.den)>(den*R.num))
					return 1;
			 else
					return 0;
	  }
	  void Rational::display()
	  {
			 if((num<0)&&(den<0))
			 {
					num=-num;
					den=-den;
			 }
			 cout<<num<<"/";
			 cout<<den;
	  }
	  void Rational::printFP()
	  {
			 float sonuc;
			 sonuc=float(num)/float(den);
			 cout<<sonuc;
	  }

	  void main()
	  {
			 Rational a,b(5),c(6,2),d(-1,2),e(-1,2);
			 cout<<"d=";
			 d.display();
			 cout<<" ";
			 cout<<"e=";
			 e.display();
			 cout<<" \n";
			 if(d==e)
					cout<<"d and e are equal\n";
			 else
					cout<<"d and e are not equal\n";

			 cout<<"b=";
			 b.display();
			 cout<<" ";
			 cout<<"e=";
			 e.display();
			 cout<<" \n";
			 if(b>e)
					cout<<"b is bigger\n";
			 else
					cout<<"e is bigger\n";

			 e = a + b * c;
			 cout<<"e=a+b*c\n";
			 cout<<"a= ";
			 a.display();
			 cout<<" ";
			 cout<<"b= ";
			 b.display();
			 cout<<" ";
			 cout<<"c= ";
			 c.display();
			 cout<<" ";
			 cout<<"e=";
			 e.display();
			 cout<<" \n";

			 e = b / d - a ;
			 cout<<"e=b/d-a\n";
			 cout<<"b= ";
			 b.display();
			 cout<<" ";
			 cout<<"a= ";
			 a.display();
			 cout<<" ";
			 cout<<"d= ";
			 d.display();
			 cout<<" ";
			 cout<<"e=";
			 e.display();
			 cout<<" \n";

			 cout<<"In floating point format e= ";
			 e.printFP();
	  }

