//						    ALI CAN SIMSEK
//						      FE99G2918
//						    ASIYE OZTURK
//						      A0009044
//
//			      ELE 492
//			    HOMEWORK #5
//
//
//OPERATOR OVERLOADING
//RATIONAL.H

#ifndef rational_h
#define rational_h
class rational {
    friend ostream &operator << ( ostream & , rational&);
    friend istream &operator >> ( istream & , rational&);
public:
    rational(int n=2, int dn=4);
    void printFP() const;
    rational operator+ (const rational &) ;
    rational operator- (const rational &) ;
    rational operator* (const rational &) ;
    rational operator/ (const rational &) ;
    void operator< (const rational &) ;
    void operator> (const rational &) ;

private:
    int numerator;
    int denominator;
    void reduce();
};
#endif
