// RATIONAL.H
// rational class definition

#ifndef RATIONAL1_H
#define RATIONAL1_H

class Rational {
	friend ostream &operator<<(ostream &, Rational &);
	friend istream &operator>>(istream &, Rational &);
public:
	Rational(int , int);
	void printfloat();
	void reduce();
	Rational operator+(Rational &);
	Rational operator-(Rational &);
	Rational operator*(Rational &);
	Rational operator/(Rational &);
	int operator<(Rational &);
	int operator>(Rational &);
	int operator==(Rational &);
private:
	int numarator;
	int denominator;
};

#endif









