#ifndef RATIO1_H
#define RATIO1_H

class RationalNumber {
 friend ostream &operator<<(ostream& , const RationalNumber&);
 friend istream &operator>>(istream&, RationalNumber&);

public:
  void print();
  RationalNumber(int = 0, int = 1);
  RationalNumber operator+ (RationalNumber&);
  RationalNumber operator- (RationalNumber&);
  RationalNumber operator* (RationalNumber&);
  RationalNumber operator/ (RationalNumber&);
  RationalNumber &operator=(RationalNumber&);
  void printInFloatForm();
  int operator>(RationalNumber&);
  int operator<(RationalNumber&);
  int operator==(RationalNumber&);
private:
  int numerator;
  int denominator;
};
#endif
